package fishrungames.bashgid;

import java.util.ArrayList;

import fishrungames.bashgid.core.AlbumManager.AlbumFullData;
import fishrungames.bashgid.core.HtmlDownloadManager;
import fishrungames.bashgid.core.JournalManager.JournalSemiFullData;

import fishrungames.bashgid.core.HtmlDownloadManager.TextFileRecord;
import fishrungames.networkutils.ImageManager;
import android.annotation.SuppressLint;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.View.OnClickListener;
import android.widget.BaseAdapter;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

public class MainPageHListViewAdapters {
	
	
	
	public static class PhotoAlbumElementAdapter extends BaseAdapter {
		
	    private Context mContext;
	    //String albumName;
	    AlbumFullData albumFullData;
	    //ArrayList<TextFileRecord> localHtmlList;

	    public PhotoAlbumElementAdapter(Context c, AlbumFullData albumFullData) {
	    	this.mContext = c;	  
	        this.albumFullData = albumFullData;

	        //localHtmlList = HtmlDownloadManager.getInstance().getGlobalHtmlList();
	    }

	    public int getCount() {
	        return albumFullData.photoRecordArr.size();
	    }

	    public Object getItem(int position) {
	        return null;
	    }

	    public long getItemId(int position) {
	        return 0;
	    }

	    // create a new ImageView for each item referenced by the Adapter
	    @SuppressLint("InflateParams")
	    public View getView(int position, View convertView, ViewGroup parent) {
	        
	    	
	    	View view;
	        if (convertView == null) {  // if it's not recycled, initialize some attributes
	        	LayoutInflater inflater = (LayoutInflater) mContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	        	view = inflater.inflate(R.layout.article_album_element_item, null);
	        	
	   
	        } else {
	        	view = convertView;
	        }
	        
	        //TextView textView = (TextView) view.findViewById(R.id.dateTextView);
	        
	        //TextView subTextView = (TextView) view.findViewById(R.id.subTextView);
	        
	        //ImageButton imageButton = (ImageButton) view.findViewById(R.id.imageButton);
	        ImageView imageView = (ImageView) view.findViewById(R.id.imageView);
	        
	        //textView.setText(albumFullData.photoRecordArr.get(position).title);
	        
	        //subTextView.setText("");
	        
	        ImageManager.getInstance().ApplyImageToImageView(imageView, albumFullData.photoRecordArr.get(position).imageUrl);
	        
	        //imageButton.setOnClickListener(new ContentButtonOnClickListener(localHtmlList.get(position)));
	        
	        return view;
	    }

	}
	
public static class JournalElementAdapter extends BaseAdapter {
		
	    private Context mContext;
	    //String albumName;
	    JournalSemiFullData journal;
	    //ArrayList<TextFileRecord> localHtmlList;

	    public JournalElementAdapter(Context c, JournalSemiFullData journal) {
	    	this.mContext = c;	  
	        this.journal = journal;

	        //localHtmlList = HtmlDownloadManager.getInstance().getGlobalHtmlList();
	    }

	    public int getCount() {
	        return journal.articleArr.size();
	    }

	    public Object getItem(int position) {
	        return null;
	    }

	    public long getItemId(int position) {
	        return 0;
	    }

	    // create a new ImageView for each item referenced by the Adapter
	    @SuppressLint("InflateParams")
	    public View getView(final int position, View convertView, ViewGroup parent) {
	        
	    	View view;
	        if (convertView == null) {  // if it's not recycled, initialize some attributes
	        	LayoutInflater inflater = (LayoutInflater) mContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	        	view = inflater.inflate(R.layout.simple_hview_list_element, null);
	        	
	   
	        } else {
	        	view = convertView;
	        }
	        
	        TextView textView = (TextView) view.findViewById(R.id.dateTextView);
	        
	        TextView subTextView = (TextView) view.findViewById(R.id.subTextView);
	        
	        ImageButton imageButton = (ImageButton) view.findViewById(R.id.imageButton);

	        
	        textView.setText(journal.articleArr.get(position).title);
	        
	        subTextView.setText(journal.articleArr.get(position).dateTime.toString());
	        
	        String imageUrl = journal.articleArr.get(position).previewImageUrl;
	        
	        ImageManager.getInstance().ApplyImageToImageView(imageButton, imageUrl);
	        
	        imageButton.setOnClickListener(new OnClickListener()
	        {

				@Override
				public void onClick(View v)
				{
					MainActivity.getInstance().OpenArticleScreen(journal.articleArr.get(position).name, MainActivity.TAG_FROM_CATALOGFRAGMENT_TO_ARTICLEFRAGMENT);
				}
	        	
	        });
	        
	        return view;
	    }

	}
	
/*
	public static class SimpleElementAdapter extends BaseAdapter {
				
	    private Context mContext;
	    ArrayList<TextFileRecord> localHtmlList;

	    public SimpleElementAdapter(Context c) {
	        mContext = c;	     

	        localHtmlList = HtmlDownloadManager.getInstance().getGlobalHtmlList();
	    }

	    public int getCount() {
	        return localHtmlList.size();
	    }

	    public Object getItem(int position) {
	        return null;
	    }

	    public long getItemId(int position) {
	        return 0;
	    }

	    // create a new ImageView for each item referenced by the Adapter
	    @SuppressLint("InflateParams")
	    public View getView(int position, View convertView, ViewGroup parent) {
	        
	    	
	    	View view;
	        if (convertView == null) {  // if it's not recycled, initialize some attributes
	        	LayoutInflater inflater = (LayoutInflater) mContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	        	view = inflater.inflate(R.layout.simple_hview_list_element, null);
	        	
	   
	        } else {
	        	view = convertView;
	        }
	        
	        TextView textView = (TextView) view.findViewById(R.id.dateTextView);
	        
	        TextView subTextView = (TextView) view.findViewById(R.id.subTextView);
	        
	        ImageButton imageButton = (ImageButton) view.findViewById(R.id.imageButton);
	        
	        textView.setText(localHtmlList.get(position).title);
	        
	        subTextView.setText("");
	        
	        ImageManager.getInstance().ApplyImageToImageView(imageButton, localHtmlList.get(position).topicImg);
	        
	        imageButton.setOnClickListener(new ContentButtonOnClickListener(localHtmlList.get(position)));
	        
	        return view;
	    }

	}*/
	
/*
	
public static class DarkenElementAdapter extends BaseAdapter {
		
	String [] textsArray;
	String [] subTextsArray;
	int [] imgIdArray;
	
    private Context mContext;

    public DarkenElementAdapter(Context c, String [] textsArray, String [] subTextsArray, int [] imgIdArray) {
        mContext = c;
        this.textsArray = textsArray;
        this.subTextsArray = subTextsArray;
        this.imgIdArray = imgIdArray;
        
    }

	    public int getCount() {
	        return textsArray.length;
	    }

	    public Object getItem(int position) {
	        return null;
	    }

	    public long getItemId(int position) {
	        return 0;
	    }

	    // create a new ImageView for each item referenced by the Adapter
	    @SuppressLint("InflateParams")
	    public View getView(int position, View convertView, ViewGroup parent) {
	        
	    	
	    	View view;
	        if (convertView == null) {  // if it's not recycled, initialize some attributes
	        	LayoutInflater inflater = (LayoutInflater) mContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
	        	view = inflater.inflate(R.layout.darken_hview_list_element, null);
	        	
	   
	        } else {
	        	view = convertView;
	        }
	        
	        TextView textView = (TextView) view.findViewById(R.id.dateTextView);
	        
	        TextView subTextView = (TextView) view.findViewById(R.id.subTextView);

	        LinearLayout linearLayout = (LinearLayout) view.findViewById(R.id.linearLayout);
	        
	        textView.setText(textsArray[position]);
	        
	        subTextView.setText(subTextsArray[position]);
	        
	        linearLayout.setBackgroundResource(imgIdArray[position]);
	        
	        return view;
	    }

	}*/
	
	
	

}
